%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Beamer Presentation
% LaTeX Template
% Version 1.0 (10/11/12)
%
% This template has been downloaded from:
% http://www.LaTeXTemplates.com
%
% License:
% CC BY-NC-SA 3.0 (http://creativecommons.org/licenses/by-nc-sa/3.0/)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%----------------------------------------------------------------------------------------
%	PACKAGES AND THEMES
%----------------------------------------------------------------------------------------

\documentclass{beamer}

\mode<presentation> {

% The Beamer class comes with a number of default slide themes
% which change the colors and layouts of slides. Below this is a list
% of all the themes, uncomment each in turn to see what they look like.

% \usetheme{default}
% \usetheme{AnnArbor}
% \usetheme{Antibes}
%\usetheme{Bergen}
% \usetheme{Berkeley}
% \usetheme{Berlin}
% \usetheme{Boadilla}
% \usetheme{CambridgeUS}
% \usetheme{Copenhagen}
% \usetheme{Darmstadt}
% \usetheme{Dresden}
% \usetheme{Frankfurt}
%\usetheme{Goettingen}
%\usetheme{Hannover}
%\usetheme{Ilmenau}
%\usetheme{JuanLesPins}
%\usetheme{Luebeck}
% \usetheme{Madrid}
%\usetheme{Malmoe}
%\usetheme{Marburg}
%\usetheme{Montpellier}
% \usetheme{PaloAlto}
% \usetheme{Pittsburgh}
% \usetheme{Rochester}
% \usetheme{Singapore}
% \usetheme{Szeged}
\usetheme{Warsaw}

% As well as themes, the Beamer class has a number of color themes
% for any slide theme. Uncomment each of these in turn to see how it
% changes the colors of your current slide theme.

% \usecolortheme{albatross}
\usecolortheme{beaver}
% \usecolortheme{beetle}
% \usecolortheme{crane}
% \usecolortheme{dolphin}
% \usecolortheme{dove}
% \usecolortheme{fly}
% \usecolortheme{lily}
% \usecolortheme{orchid}
% % \usecolortheme{rose}
% \usecolortheme{seagull}
% \usecolortheme{seahorse}
% \usecolortheme{whale}
% \usecolortheme{wolverine}

%\setbeamertemplate{footline} % To remove the footer line in all slides uncomment this line
\setbeamertemplate{footline}[page number] % To replace the footer line in all slides with a simple slide count uncomment this line

\setbeamertemplate{navigation symbols}{} % To remove the navigation symbols from the bottom of all slides uncomment this line
}

\usepackage{graphicx} % Allows including images
\usepackage{booktabs} % Allows the use of \toprule, \midrule and \bottomrule in tables
\usepackage[spanish]{babel}
\usepackage[utf8]{inputenc}
\usepackage{upgreek}
\usepackage{ dsfont }
\usepackage{tikz}

\usepackage{listings}
\definecolor{codegreen}{rgb}{0,0.6,0}
\definecolor{codegray}{rgb}{0.5,0.5,0.5}
\definecolor{codepurple}{rgb}{0.58,0,0.82}
\definecolor{codepurple}{rgb}{0.1, 1.0, 1.0}
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}
 
\lstdefinestyle{mystyle}{
    backgroundcolor=\color{backcolour},   
    commentstyle=\color{codegreen},
    keywordstyle=\color{magenta},
    numberstyle=\tiny\color{codegray},
    stringstyle=\color{codepurple},
    basicstyle=\footnotesize,
    breakatwhitespace=false,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=2
}
\lstset{style=mystyle}


%----------------------------------------------------------------------------------------
%	TITLE PAGE
%----------------------------------------------------------------------------------------

\title[Short title]{Visualización de datos geométricos con pyVista} % The short title appears at the bottom of every slide, the full title is only on the title page

\author{Camilo Rojas Milla} % Your name
\institute[] % Your institution as it will appear on the bottom of every slide, may be shorthand to save space
{
% University of California \\ % Your institution for the title page
\medskip
\textit{camrojas@uchile.cl} % Your email address
}
\date{\today} % Date, can be changed to a custom date

\begin{document}

\begin{frame}
\titlepage % Print the title page as the first slide
\end{frame}

\begin{frame}
\frametitle{Resumen} % Table of contents slide, comment this block out to remove it
\tableofcontents % Throughout your presentation, if you choose to use \section{} and \subsection{} commands, these will automatically be printed on this slide as an overview of your presentation
\end{frame}

%----------------------------------------------------------------------------------------
%	PRESENTATION SLIDES
%----------------------------------------------------------------------------------------

%------------------------------------------------
% \section{Resumen} % Sections can be created in order to organize your presentation into discrete blocks, all sections and subsections are automatically printed in the table of contents as an overview of the talk
%------------------------------------------------

% \subsection{Repaso AFD} % A subsection can be created just before a set of slides with a common theme to further break down your presentation into chunks

% \begin{frame}
% \frametitle{Resumen}
% La visualización de grandes dataset geométricos es una tarea desafiante con respecto a los recursos computacionales a utilizar versus el número de polígonos a mostrar. Las bibliotecas que existen para facilitar el gráfico rapido y agil se basan en alternativas web (WebGL) o alternativas de escritorio (OpenGL) siendo estas ultimas mas potentes pero complejas en cuanto a programación y proximidad con el hardware. PyVista \footnote{https://pypi.org/project/pyvista/} nace como una alternativa \it{open source} que mezcla la agilidad de python-matplotlib con la robustez de VTK. En esta presentación se explorará algunas de las capacidades de pyVista. En particular se revisará la visualización de: nube de puntos, triangulaciones de superficies y tetraedros.
% \end{frame}


\section{Datos Geométricos}

\subsection{Utilidades}
\begin{frame}
\frametitle{Utilidades de Datos Geométricos}
\footnote{http://wias-berlin.de/software/tetgen/}
   \begin{columns}[c]
   \column{.45\textwidth} % Left column and width
   {\bf Usos y Utilidades:}
   \begin{enumerate}
    \item Modelos Topológicos (Lidar)
    \item Interpolación ('Heat Maps')
    \item Elementos Finitos (Campos Electromagnéticos, Presión, entre Otros)
    $\vec{\nabla} \times \vec{E} = - \frac{\partial \vec{B}}{\partial t}$
   \end{enumerate}
   \column{.45\textwidth}
       \begin{figure}
        \includegraphics[width=0.7\linewidth]{weiss_meshs.png}
    \end{figure}
%     
    
  \end{columns}
\end{frame}


\subsection{Primitivas Geométricas}
\begin{frame}
\frametitle{Ejemplos de datos Geométricos}
   \begin{columns}[c]
   \column{.45\textwidth} % Left column and width
   {\bf Datasets:}
   \begin{enumerate}
    \item {\bf Nube de Puntos}
    \item Triangulaciones 2D, 3D
    \item Poliedros
   \end{enumerate}
   \column{.45\textwidth}
       \begin{figure}
        \includegraphics[width=\linewidth]{bary_test_3.png}
    \end{figure}
  \end{columns}
\end{frame}

\begin{frame}
\frametitle{Ejemplos de datos Geométricos}
   \begin{columns}[c]
   \column{.45\textwidth} % Left column and width
   {\bf Datasets:}
   \begin{enumerate}
    \item Nube de Puntos
    \item {\bf Triangulaciones 2D, 3D}
    \item Poliedros
   \end{enumerate}
   \column{.45\textwidth}
       \begin{figure}
        \includegraphics[width=\linewidth]{top_bot_1.png}
    \end{figure}
  \end{columns}
\end{frame}

\begin{frame}
\frametitle{Ejemplos de datos Geométricos}
   \begin{columns}[c]
   \column{.45\textwidth} % Left column and width
   {\bf Datasets:}
   \begin{enumerate}
    \item Nube de Puntos
    \item Triangulaciones 2D, 3D
    \item {\bf Poliedros}
   \end{enumerate}
   \column{.45\textwidth}
       \begin{figure}
        \includegraphics[width=\linewidth]{tet_prism_1.png}
    \end{figure}
  \end{columns}
\end{frame}

\subsection{Representación}
\begin{frame}
 \frametitle{Representación}
 \begin{columns}[c]
 \column{.45\textwidth}
\begin{figure}
    \includegraphics[width=\linewidth]{points_off.png}
    \ \\
    \includegraphics[width=0.5\linewidth]{trs_off.png}
\end{figure}
 
 
 \column{.6\textwidth}
 \pause
 $\Rightarrow X  =[X_i] \text{ donde } X_i = [x_i, y_i, z_i]$
 \\
 $ T = [T_i] \text{ donde } T_i = [p, q, r]$
 \\
 $ X \rightarrow (N \times 3) \text{ y } p, q,r \in \{1,\ldots,N\}$
 \end{columns}
\end{frame}

\begin{frame}
 \frametitle{Alternativas de Visualización}
  \begin{tikzpicture}
  
      \node[anchor=south west,inner sep=0] at (0,0) {\includegraphics[width=0.9\textwidth]{viz.png}};
%     \draw[red,ultra thick,rounded corners] (7.5,5.3) rectangle (9.4,6.2)
%    \draw[red,ultra thick] (5,0.6) circle (1.5cm);
  \end{tikzpicture}
\end{frame}

\begin{frame}
 \frametitle{Alternativas de Visualización}
  \begin{tikzpicture}
  
      \node[anchor=south west,inner sep=0] at (0,0) {\includegraphics[width=0.9\textwidth]{viz.png}};
%     \draw[red,ultra thick,rounded corners] (7.5,5.3) rectangle (9.4,6.2)
   \draw[red,ultra thick] (5,0.6) circle (1.5cm);
  \end{tikzpicture}
\end{frame}

\section{Pyvista}
\subsection{Nube de Puntos}
\begin{frame}
\frametitle{Nube de puntos (plot\_scatter)}

\lstinputlisting[language=Python,frame=L,caption=plot\_scatter,label=unfold_pc, basicstyle=\tiny]{plot_scatter.py}
Demo: \url{http://localhost:8888/notebooks/demo.ipynb}
 
\end{frame}

\subsection{Superficies}
\begin{frame}
\frametitle{Triángulos 2D, 3D (plot\_surface)}

\lstinputlisting[language=Python,frame=L,caption=plot\_surface,label=unfold_pc, basicstyle=\tiny]{plot_surface.py}
Demo: \url{http://localhost:8888/notebooks/demo.ipynb}
 
\end{frame}

\subsection{Tetraedros}
\begin{frame}
\frametitle{Tetraedros (plot\_tetras)}

\lstinputlisting[language=Python,frame=L,caption=plot\_tetras,label=unfold_pc, basicstyle=\tiny]{plot_tetras.py}
 
\end{frame}


\section{Preguntas}

\begin{frame}
\Huge{\centerline{FIN}}

\large{\centerline{Preguntas ?}}
\large{repositorio: \url{https://gitlab.com/camilo.rojas/viz_pyvista_lecture} }

\end{frame}

%----------------------------------------------------------------------------------------

\end{document} 
